using NwndAdHcWaAPI.Domain;
using NwndAdHcWaAPI.BusinessObject;
using Microsoft.AspNetCore.Mvc;
using System;
using System.Net.Http;
using System.Text.Json;
using System.Threading.Tasks;

namespace NwndAdHcWa
{
     public class CategoriesFunctions
     {
         private CategoriesFunctions()
         {
         }

         /// <summary>
         /// Used when adding or updating a record.
         /// </summary>
         internal static async Task<IActionResult> AddOrEditAsync(Categories model, CrudOperation operation, bool isForListInlineOrListCrud = false)
         {
             // serialize the model to json
             string serializedModel = JsonSerializer.Serialize(model);

             // web api url for Add
             string webApiUrl = "CategoriesApi/Insert?isForListInlineOrListCrud=" + isForListInlineOrListCrud;

             // web api url for Update
             if (operation == CrudOperation.Update)
                 webApiUrl = "CategoriesApi/Update?isForListInlineOrListCrud=" + isForListInlineOrListCrud;

             // post data via web api
             HttpResponseMessage response = await Functions.HttpClientPostAsync(webApiUrl, serializedModel);

             // check the status of the httpclient post operation
             if (response != null)
             {
                 if (response.IsSuccessStatusCode)
                     return new OkResult();
                 else
                     throw new Exception("Error Status Code: " + response.StatusCode.ToString() + " Error Reason: " + response.ReasonPhrase + " Error Message: " + response.RequestMessage.ToString());
             }

             return new BadRequestResult();
         }
     }
}
