using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using NwndAdHcWaAPI.Domain;
using NwndAdHcWaAPI.BusinessObject;
using System.Net.Http;
using System.Text.Json;
using System.Threading.Tasks;

namespace NwndAdHcWa.Pages
{
     public class Suppliers_DetailsModel : PageModel
     {
         [BindProperty]
         public NwndAdHcWaAPI.BusinessObject.Suppliers Suppliers { get; set; }

         [BindProperty]
         public string ReturnUrl { get; set; }

         /// <summary>
         /// Initial handler the razor page encounters.
         /// </summary>
         public async Task OnGetAsync(int id, string returnUrl)
         {
             await LoadPageAsync(id, returnUrl);
         }

         public async Task LoadPageAsync(int id, string returnUrl)
         {
             // select a record by primary key(s)
             NwndAdHcWaAPI.BusinessObject.Suppliers objSuppliers = await GetSuppliersByPrimaryKeyAsync(id);

             // assign values to this page's bound property
             Suppliers = objSuppliers;

             // assign the return url
             ReturnUrl = returnUrl;
         }

         private async Task<Suppliers> GetSuppliersByPrimaryKeyAsync(int supplierID)
         {
             string responseBody = await Functions.HttpClientGetAsync("SuppliersApi/SelectByPrimaryKey/" + supplierID);
             Suppliers objSuppliers = JsonSerializer.Deserialize<Suppliers>(responseBody);

             return objSuppliers;
         }
     }
}
