using System; 
using System.Text; 

namespace NwndAdHcWaAPI.DataLayer.Base
{ 
    internal sealed class CategoriesSql 
    { 
        private CategoriesSql() 
        { 
        } 

        internal static string SelectByPrimaryKey() 
        { 
            string selectStatement = GetSelectStatement(); 
            StringBuilder sb = new StringBuilder(); 

            sb.Append(selectStatement);
            sb.Append(" WHERE "); 
            sb.Append("[CategoryID] = @categoryID ");

            return sb.ToString(); 
        } 

        internal static string GetRecordCount() 
        { 
            StringBuilder sb = new StringBuilder(); 

            sb.Append("SELECT COUNT(*) AS RecordCount FROM [dbo].[Categories]");

            return sb.ToString(); 
        } 

        internal static string GetRecordCountDynamicWhere() 
        { 
            StringBuilder sb = new StringBuilder(); 

            sb.Append("SELECT COUNT(*) AS RecordCount FROM [dbo].[Categories]");

            sb.Append(" WHERE ");
            sb.Append("([CategoryID] = @categoryID OR @categoryID IS NULL) AND ");
            sb.Append("([CategoryName] LIKE '%' + @categoryName + '%' OR @categoryName IS NULL) ");

            return sb.ToString(); 
        } 

        internal static string SelectSkipAndTake() 
        { 
            string selectStatement = GetSelectStatement(); 
            StringBuilder sb = new StringBuilder(); 

            sb.Append("DECLARE @numberOfRowsToSkip int = @start; ");

            sb.Append("SELECT ");
            sb.Append("[CategoryID], ");
            sb.Append("[CategoryName], ");
            sb.Append("[Description] ");
            sb.Append("FROM [dbo].[Categories] ");
            sb.Append("ORDER BY ");
	        sb.Append("CASE WHEN @sortByExpression = 'CategoryID' THEN [CategoryID] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'CategoryID desc' THEN [CategoryID] END DESC, ");

	        sb.Append("CASE WHEN @sortByExpression = 'CategoryName' THEN [CategoryName] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'CategoryName desc' THEN [CategoryName] END DESC ");

            sb.Append("OFFSET @numberOfRowsToSkip ROWS ");
            sb.Append("FETCH NEXT @numberOfRows ROWS ONLY ");

            return sb.ToString(); 
        } 

        internal static string SelectSkipAndTakeDynamicWhere() 
        { 
            StringBuilder sb = new StringBuilder(); 

            sb.Append("DECLARE @numberOfRowsToSkip int = @start; ");

            sb.Append("SELECT ");
            sb.Append("[CategoryID], ");
            sb.Append("[CategoryName], ");
            sb.Append("[Description] ");
            sb.Append("FROM [dbo].[Categories] ");
            sb.Append(" WHERE ");
            sb.Append("([CategoryID] = @categoryID OR @categoryID IS NULL) AND ");
            sb.Append("([CategoryName] LIKE '%' + @categoryName + '%' OR @categoryName IS NULL) ");

            sb.Append("ORDER BY ");
	        sb.Append("CASE WHEN @sortByExpression = 'CategoryID' THEN [CategoryID] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'CategoryID desc' THEN [CategoryID] END DESC, ");

	        sb.Append("CASE WHEN @sortByExpression = 'CategoryName' THEN [CategoryName] END, ");
	        sb.Append("CASE WHEN @sortByExpression = 'CategoryName desc' THEN [CategoryName] END DESC ");

            sb.Append("OFFSET @numberOfRowsToSkip ROWS ");
            sb.Append("FETCH NEXT @numberOfRows ROWS ONLY ");

            return sb.ToString(); 
        } 

        internal static string SelectAll() 
        { 
            string selectStatement = GetSelectStatement(); 
            StringBuilder sb = new StringBuilder(); 

            sb.Append(selectStatement);

            return sb.ToString(); 
        } 

        internal static string SelectAllDynamicWhere()
        {
            string selectStatement = GetSelectStatement();
            StringBuilder sb = new StringBuilder();

            sb.Append(selectStatement);
            sb.Append(" WHERE ");
            sb.Append("([CategoryID] = @categoryID OR @categoryID IS NULL) AND ");
            sb.Append("([CategoryName] LIKE '%' + @categoryName + '%' OR @categoryName IS NULL) ");

            return sb.ToString();
        } 

        /// <summary>
        /// Selects CategoryID and CategoryName columns for use with a DropDownList web control
        /// </summary>
        internal static string SelectCategoriesDropDownListData()
        { 
            string selectStatement = "SELECT [CategoryID], [CategoryName] FROM [dbo].[Categories] ORDER BY [CategoryName] ASC "; 
            StringBuilder sb = new StringBuilder(); 

            sb.Append(selectStatement);

            return sb.ToString(); 
        } 

        internal static string Insert()
        { 
            StringBuilder sb = new StringBuilder(); 

            sb.Append("INSERT INTO [dbo].[Categories] ");
            sb.Append("(");
            sb.Append("[CategoryName], ");
            sb.Append("[Description] ");
            sb.Append(") ");
            sb.Append("OUTPUT inserted.[CategoryID] ");
            sb.Append("VALUES ");
            sb.Append("(");
            sb.Append("@categoryName,");
            sb.Append("@description");
            sb.Append(")");

            return sb.ToString(); 
        } 

        internal static string Update()
        { 
            StringBuilder sb = new StringBuilder(); 

            sb.Append("UPDATE [dbo].[Categories] ");
            sb.Append("SET ");
            sb.Append("[CategoryName] = @categoryName,");
            sb.Append("[Description] = @description");
            sb.Append(" WHERE "); 
            sb.Append("[CategoryID] = @categoryID ");

            return sb.ToString(); 
        } 

        internal static string Delete() 
        { 
            StringBuilder sb = new StringBuilder(); 

            sb.Append("DELETE FROM [dbo].[Categories] ");
            sb.Append(" WHERE "); 
            sb.Append("[CategoryID] = @categoryID ");

            return sb.ToString(); 
        } 

        private static string GetSelectStatement() 
        { 
            StringBuilder sb = new StringBuilder(); 

            sb.Append("SELECT ");
            sb.Append("[CategoryID], ");
            sb.Append("[CategoryName], ");
            sb.Append("[Description] ");
            sb.Append("FROM [dbo].[Categories] ");

            return sb.ToString(); 
        } 
    } 
} 
